diff --git a/src/main/java/net/minecraft/core/net/command/commands/BiomeCommand.java b/src/main/java/net/minecraft/core/net/command/commands/BiomeCommand.java
index 389259946..827916db2 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/BiomeCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/BiomeCommand.java
@@ -1,143 +1,82 @@
 package net.minecraft.core.net.command.commands;
 
+import com.mojang.brigadier.Command;
+import com.mojang.brigadier.CommandDispatcher;
+import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import com.mojang.brigadier.exceptions.DynamicCommandExceptionType;
 import net.minecraft.core.data.registry.Registries;
-import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.net.command.*;
-import net.minecraft.core.world.World;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.biome.Biome;
-import net.minecraft.core.world.chunk.Chunk;
-import net.minecraft.core.world.chunk.ChunkSection;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.command.arguments.BiomeArgumentType;
+import net.minecraft.core.net.command.arguments.IntegerCoordinatesArgumentType;
+import net.minecraft.core.net.command.helpers.Coordinates2D;
+import net.minecraft.core.net.command.helpers.IntegerCoordinates;
 
-public class BiomeCommand
-extends Command {
-    public BiomeCommand() {
-        super("biome");
-    }
+public class BiomeCommand {
+    private static final DynamicCommandExceptionType FAILURE = new DynamicCommandExceptionType(arg -> () -> I18n.getInstance().translateKeyAndFormat("command.commands.biome.locate.exception_failure", arg));
 
-    @Override
-    public boolean execute(CommandHandler handler, CommandSender sender, String[] args) {
-        if (args.length == 0 && sender instanceof PlayerCommandSender) {
-            Player p = sender.getPlayer();
-            World world = p.world;
-            Biome biome = world.getBlockBiome((int) p.x, (int) p.y, (int) p.z);
-            sender.sendMessage("Current biome: " + Registries.BIOMES.getKey(biome));
-            return true;
-        } else if (args.length >= 1) {
-            if (args[0].equalsIgnoreCase("list")) {
-                sender.sendMessage("Biomes:");
-                for (Biome biome : Registries.BIOMES) {
-                    String key = Registries.BIOMES.getKey(biome);
-                    if (args.length == 1 || (args.length == 2 && key.startsWith(args[1]))) {
-                        sender.sendMessage(" - " + Registries.BIOMES.getKey(biome));
-                    }
-                }
-                return true;
-            } else if (args.length == 2 && args[0].equalsIgnoreCase("locate") && sender instanceof PlayerCommandSender) {
-                Biome biome = Registries.BIOMES.getItem(args[1]);
-                if (biome == null) {
-                    sender.sendMessage("Unknown biome: " + args[1]);
-                } else {
-                    int[] nearest = getBiomeCoords(biome, sender.getPlayer());
-                    if (nearest == null) {
-                        sender.sendMessage("No biome found!");
-                    } else {
-                        sender.sendMessage("Biome located at: " + nearest[0] + ", " + nearest[1]);
-                    }
-                }
-                return true;
-            } else if (args.length == 2 && args[0].equalsIgnoreCase("set") && sender instanceof PlayerCommandSender) {
-                Biome biome = Registries.BIOMES.getItem(args[1]);
-                if (biome == null) {
-                    sender.sendMessage("Unknown biome: " + args[1]);
-                } else {
-                    Chunk chunk = sender.getPlayer().world.getChunkFromBlockCoords((int) sender.getPlayer().x, (int) sender.getPlayer().z);
-                    for (int x = 0; x < Chunk.CHUNK_SIZE_X; x++) {
-                        for (int z = 0; z < Chunk.CHUNK_SIZE_Z; z++) {
-                            for (int y = 0; y < Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y; y++) {
-                                chunk.setBlockBiome(x, y, z, biome);
-                            }
-                        }
-                    }
-                    sender.sendMessage("Set chunk biome to " + args[1]);
-                }
-                return true;
-            } else if (args.length <= 2 && args[0].equalsIgnoreCase("reset") && sender instanceof PlayerCommandSender) {
-                int radius = 1;
-                if (args.length == 2){
-                     radius = Integer.parseInt(args[1]);
-                }
-                for (int _x = -radius; _x < radius; _x++) {
-                    for (int _z = -radius; _z < radius; _z++) {
-                        int chunkX = sender.getPlayer().chunkCoordX + _x;
-                        int chunkZ = sender.getPlayer().chunkCoordZ + _z;
-                        if (!sender.getPlayer().world.isChunkLoaded(chunkX, chunkZ)) continue;
-                        Chunk chunk = sender.getPlayer().world.getChunkFromChunkCoords(chunkX, chunkZ);
-                        for (int x = 0; x < Chunk.CHUNK_SIZE_X; x++) {
-                            for (int z = 0; z < Chunk.CHUNK_SIZE_Z; z++) {
-                                for (int y = 0; y < Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y; y++) {
-                                    chunk.setBlockBiome(x, y, z, sender.getPlayer().world.getBiomeProvider().getBiome(chunk.xPosition * Chunk.CHUNK_SIZE_X + x, y, chunk.zPosition * Chunk.CHUNK_SIZE_Z + z));
-                                }
-                            }
-                        }
-                    }
-                }
-                sender.sendMessage("Reset chunk biomes");
-                return true;
-            } else {
-                return false;
-            }
-        } else {
-            return false;
-        }
+    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("biome")
+                .requires(CommandSource::hasAdmin)
+                .then(LiteralArgumentBuilder.<CommandSource>literal("get")
+                        .then(RequiredArgumentBuilder.<CommandSource, IntegerCoordinates>argument("position", IntegerCoordinatesArgumentType.intCoordinates())
+                                .executes(c -> {
+                                    IntegerCoordinates position = c.getArgument("position", IntegerCoordinates.class);
+                                    Biome biome = c.getSource().getWorld().getBlockBiome(position.getX(c.getSource()), position.getY(c.getSource(), true), position.getZ(c.getSource()));
+                                    c.getSource().sendTranslatableMessage("command.commands.biome.get.success", position.getX(c.getSource()), position.getY(c.getSource(), true), position.getZ(c.getSource()), Registries.BIOMES.getKey(biome));
+                                    return Command.SINGLE_SUCCESS;
+                                })))
+                .then(LiteralArgumentBuilder.<CommandSource>literal("locate")
+                        .then(RequiredArgumentBuilder.<CommandSource, Biome>argument("biome", BiomeArgumentType.biome())
+                                .executes(c -> {
+                                    Biome biome = c.getArgument("biome", Biome.class);
+                                    Coordinates2D biomeLocation = getBiomeCoords(biome, c.getSource());
+                                    if (biomeLocation == null) throw FAILURE.create(Registries.BIOMES.getKey(biome));
+                                    Vec3 sourcePos = c.getSource().getBlockCoordinates();
+                                    if (sourcePos == null) {
+                                        c.getSource().sendTranslatableMessage("command.commands.biome.locate.success", Registries.BIOMES.getKey(biome), biomeLocation.getX(c.getSource()), biomeLocation.getZ(c.getSource()));
+                                    } else {
+                                        int distance = (int)sourcePos.distanceTo(Vec3.getTempVec3(biomeLocation.getX(c.getSource()), sourcePos.y, biomeLocation.getZ(c.getSource())));
+                                        c.getSource().sendTranslatableMessage(distance == 1 ? "command.commands.biome.locate.success_in_world_single" : "command.commands.biome.locate.success_in_world_multiple", Registries.BIOMES.getKey(biome), biomeLocation.getX(c.getSource()), biomeLocation.getZ(c.getSource()), distance);
+                                    }
+                                    return Command.SINGLE_SUCCESS;
+                                }))));
     }
 
-    @Override
-    public boolean opRequired(String[] args) {
-        return true;
-    }
-
-    @Override
-    public void sendCommandSyntax(CommandHandler handler, CommandSender sender) {
-        if (sender instanceof PlayerCommandSender) {
-            sender.sendMessage("/biome");
-        }
-        sender.sendMessage("/biome list [filter]");
-        if (sender instanceof PlayerCommandSender) {
-            sender.sendMessage("/biome locate <biome>");
-            sender.sendMessage("/biome set <biome>");
-            sender.sendMessage("/biome reset [range]");
-        }
-    }
-
-    private int[] getBiomeCoords(Biome biome, Player source) {
-        int[] xPattern = new int[] { 0, 1, 0, -1 };
-        int[] zPattern = new int[] { 1, 0, -1, 0 };
+    private static Coordinates2D getBiomeCoords(Biome biome, CommandSource source) {
+        int[] xPattern = new int[]{0, 1, 0, -1};
+        int[] zPattern = new int[]{1, 0, -1, 0};
+        Vec3 sourcePos = source.getBlockCoordinates();
+        if (sourcePos == null) sourcePos = Vec3.getTempVec3(0.0, 0.0, 0.0);
         int runLength = 2;
-        int chunkX = (int) (source.x / 16);
-        int y = (int) source.y;
-        int chunkZ = (int) (source.z / 16);
+        int chunkX = (int)(sourcePos.x / 16.0);
+        int y = (int)sourcePos.y;
+        int chunkZ = (int)(sourcePos.z / 16.0);
         int passes = 1024;
+        if (source.getWorld().getBlockBiome((int)sourcePos.x, y, (int)sourcePos.z) == biome) {
+            return new Coordinates2D((int)sourcePos.x, (int)sourcePos.z);
+        } else {
+            --chunkX;
+            --chunkZ;
 
-        if (source.world.getBlockBiome(chunkX * 16, y, chunkZ * 16) == biome) {
-            return new int[] { chunkX * 16, chunkZ * 16 };
-        }
-
-        chunkX--;
-        chunkZ--;
-
-        for (int pass = 0; pass < passes; pass++) {
-            for (int i = 0; i < 4; i++) {
-                for (int j = runLength - 1; j >= 0; j--) {
-                    chunkX += xPattern[i];
-                    chunkZ += zPattern[i];
-                    if (source.world.getBlockBiome(chunkX * 16, y, chunkZ * 16) == biome) {
-                        return new int[] { chunkX * 16, chunkZ * 16 };
+            for(int pass = 0; pass < passes; ++pass) {
+                for(int i = 0; i < 4; ++i) {
+                    for(int j = runLength - 1; j >= 0; --j) {
+                        chunkX += xPattern[i];
+                        chunkZ += zPattern[i];
+                        if (source.getWorld().getBlockBiome(chunkX * 16, y, chunkZ * 16) == biome) {
+                            return new Coordinates2D(chunkX * 16, chunkZ * 16);
+                        }
                     }
                 }
+
+                ++runLength;
             }
-            runLength++;
-        }
 
-        return null;
+            return null;
+        }
     }
 }
diff --git a/src/main/java/net/minecraft/core/net/command/commands/ChunkCommand.java b/src/main/java/net/minecraft/core/net/command/commands/ChunkCommand.java
index 353a82056..dddb37b1a 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/ChunkCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/ChunkCommand.java
@@ -1,94 +1,35 @@
-package net.minecraft.core.net.command.commands;
-
-import net.minecraft.core.net.command.*;
-import net.minecraft.core.world.World;
-
-public class ChunkCommand extends Command
-{
-    public ChunkCommand()
-    {
-        super("chunk");
-    }
-
-    @Override
-    public boolean execute(CommandHandler handler, CommandSender sender, String[] args)
-    {
-        if (args[0].equalsIgnoreCase("regen"))
-        {
-            World world = null;
-            int x = Integer.MAX_VALUE;
-            int z = Integer.MAX_VALUE;
-
-            if(sender instanceof PlayerCommandSender)
-            {
-                world = sender.getPlayer().world;
-                if (args.length == 3)
-                {
-                    if (args[1].equalsIgnoreCase("~"))
-                    {
-                        x = sender.getPlayer().chunkCoordX;
-                    }
-                    else
-                    {
-                        x = Integer.parseInt(args[1]);
-                    }
-                    if (args[2].equalsIgnoreCase("~"))
-                    {
-                        z = sender.getPlayer().chunkCoordZ;
-                    }
-                    else
-                    {
-                        z = Integer.parseInt(args[2]);
-                    }
-                }
-            }
-
-            if(handler instanceof ServerCommandHandler)
-            {
-                if(args.length == 4)
-                {
-                    ServerCommandHandler server = (ServerCommandHandler) handler;
-                    int dim = Integer.parseInt(args[3]);
-
-                    world = server.minecraftServer.getDimensionWorld(dim);
-                    x = Integer.parseInt(args[1]);
-                    z = Integer.parseInt(args[2]);
-
-                }
-            }
-
-            if(world == null) throw new CommandError("Must be used by a player, or a dimension must be defined!");
-            if (x == Integer.MAX_VALUE || z == Integer.MAX_VALUE)
-            {
-                throw new CommandError("Please provide a valid value for X/Z!");
-            }
-
-            world.getChunkProvider().regenerateChunk(x, z);
-            return true;
-        }
-        else
-        {
-            return false;
-        }
-    }
-
-    @Override
-    public boolean opRequired(String[] args)
-    {
-        return true;
-    }
-
-    @Override
-    public void sendCommandSyntax(CommandHandler handler, CommandSender sender)
-    {
-        if (sender instanceof PlayerCommandSender)
-        {
-            sender.sendMessage("/chunk regen <x> <z>");
-            sender.sendMessage("/chunk regen ~ ~");
-        }
-        else
-        {
-            sender.sendMessage("/chunk regen <x> <z> <dimension>");
-        }
-    }
-}
+package net.minecraft.core.net.command.commands;
+
+import com.mojang.brigadier.Command;
+import com.mojang.brigadier.CommandDispatcher;
+import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.command.arguments.ChunkCoordinatesArgumentType;
+import net.minecraft.core.net.command.helpers.Coordinates2D;
+import net.minecraft.core.world.LevelListener;
+import net.minecraft.core.world.World;
+
+public class ChunkCommand {
+    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("chunk")
+            .requires(CommandSource::hasAdmin)
+            .then(LiteralArgumentBuilder.<CommandSource>literal("reset")
+                .then(RequiredArgumentBuilder.<CommandSource, Coordinates2D>argument("position", ChunkCoordinatesArgumentType.chunkCoordinates())
+                    .executes(c -> {
+                        CommandSource source = c.getSource();
+                        Coordinates2D coordinates2D = c.getArgument("position", Coordinates2D.class);
+                        World world = source.getWorld();
+
+                        int x = coordinates2D.getX(source);
+                        int z = coordinates2D.getZ(source);
+
+                        world.getChunkProvider().regenerateChunk(x, z);
+                        for (LevelListener listener : world.listeners) {
+                            listener.allChanged(false, true);
+                        }
+                        source.sendTranslatableMessage("command.commands.chunk.reset.success", x, z);
+                        return Command.SINGLE_SUCCESS;
+                    }))));
+    }
+}
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/core/net/command/commands/ClearCommand.java b/src/main/java/net/minecraft/core/net/command/commands/ClearCommand.java
index af5c9e909..2d8738511 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/ClearCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/ClearCommand.java
@@ -1,52 +1,136 @@
 package net.minecraft.core.net.command.commands;
 
+import com.mojang.brigadier.Command;
+import com.mojang.brigadier.CommandDispatcher;
+import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import com.mojang.brigadier.exceptions.SimpleCommandExceptionType;
+import com.mojang.logging.LogUtils;
+import com.mojang.nbt.Tag;
+import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.net.command.Command;
-import net.minecraft.core.net.command.CommandError;
-import net.minecraft.core.net.command.CommandHandler;
-import net.minecraft.core.net.command.CommandSender;
-import net.minecraft.core.net.command.PlayerCommandSender;
-
-import java.util.Arrays;
-
-public class ClearCommand extends Command{
-
-	public ClearCommand() {
-		super("clear");
-	}
-
-	@Override
-	public boolean execute(CommandHandler handler, CommandSender sender, String[] args) {
-		Player player = null;
-		
-		if(args.length == 0) {
-			player = sender.getPlayer();
-		}
-		if(args.length == 1) {
-			player = handler.getPlayer(args[0]);
-		}
-		
-		if(player == null) throw new CommandError("Must be used by a player, or define a player name!");
-		
-		for(int i = 0; i < player.inventory.getContainerSize(); i++) {
-			player.inventory.setItem(i, null);
-		}
-		Arrays.fill(player.inventory.armorInventory, null);
-		
-		return true;
-	}
-
-	@Override
-	public boolean opRequired(String[] args) {
-		return true;
-	}
-
-	@Override
-	public void sendCommandSyntax(CommandHandler handler, CommandSender sender) {
-		if(sender instanceof PlayerCommandSender) {
-			sender.sendMessage("/clear");
-		}
-		sender.sendMessage("/clear <player>");
-	}
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.command.arguments.EntityArgumentType;
+import net.minecraft.core.net.command.arguments.ItemStackArgumentType;
+import net.minecraft.core.net.command.exceptions.CommandExceptions;
+import net.minecraft.core.net.command.helpers.EntitySelector;
+import org.jetbrains.annotations.Nullable;
+import org.slf4j.Logger;
 
+import java.util.Collections;
+import java.util.List;
+import java.util.Map;
+
+public class ClearCommand {
+    private static final Logger LOGGER = LogUtils.getLogger();
+
+    private static final SimpleCommandExceptionType FAILURE = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.commands.clear.exception_failure"));
+
+    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("clear")
+            .requires(CommandSource::hasAdmin)
+            .executes(c -> {
+                CommandSource source = c.getSource();
+                Player sender = source.getSender();
+
+                if (sender == null) throw CommandExceptions.notInWorld().create();
+
+                int itemsCleared = clearItemsFromEntity(sender, null);
+
+                if (itemsCleared == 0) throw FAILURE.create();
+                source.sendMessage(getMessage(itemsCleared, Collections.singletonList(sender)));
+
+                return Command.SINGLE_SUCCESS;
+            })
+            .then(RequiredArgumentBuilder.<CommandSource, EntitySelector>argument("players", EntityArgumentType.players())
+                .executes(c -> {
+                    CommandSource source = c.getSource();
+                    List<? extends Entity> players = c.getArgument("players", EntitySelector.class).get(source);
+
+                    int itemsCleared = 0;
+
+                    for (Entity player : players) {
+                        itemsCleared += clearItemsFromEntity((Player) player, null);
+                    }
+
+                    if (itemsCleared == 0) throw FAILURE.create();
+                    source.sendMessage(getMessage(itemsCleared, players));
+
+                    return Command.SINGLE_SUCCESS;
+                })
+                .then(RequiredArgumentBuilder.<CommandSource, ItemStack>argument("item", ItemStackArgumentType.itemStack())
+                    .executes(c -> {
+                        CommandSource source = c.getSource();
+                        List<? extends Entity> players = c.getArgument("players", EntitySelector.class).get(source);
+                        ItemStack itemStack = c.getArgument("item", ItemStack.class);
+
+                        int itemsCleared = 0;
+
+                        for (Entity player : players) {
+                            itemsCleared += clearItemsFromEntity((Player) player, itemStack);
+                        }
+
+                        if (itemsCleared == 0) throw FAILURE.create();
+                        source.sendMessage(getMessage(itemsCleared, players));
+
+                        return Command.SINGLE_SUCCESS;
+                    }))));
+    }
+
+    private static int clearItemsFromEntity(Player entityPlayer, @Nullable ItemStack itemStack) {
+        int itemsCleared = 0;
+
+        for (int i = 0; i < entityPlayer.inventory.getContainerSize(); ++i) {
+            ItemStack stackInSlot = entityPlayer.inventory.getItem(i);
+            if (stackInSlot != null && (itemStack == null || matchesItemStack(itemStack, stackInSlot))) {
+                itemsCleared++;
+                entityPlayer.inventory.setItem(i, null);
+            }
+        }
+
+        return itemsCleared;
+    }
+
+    private static boolean matchesItemStack(ItemStack checkedStack, ItemStack input) {
+        ItemStack checkedStackCopy = checkedStack.copy();
+        ItemStack inputCopy = input.copy();
+        checkedStackCopy.stackSize = 1;
+        inputCopy.stackSize = 1;
+        if (checkedStackCopy.getData().getValues().isEmpty()) {
+            return checkedStackCopy.isStackEqual(inputCopy);
+        }
+        LOGGER.info(checkedStackCopy.itemID + ", " + inputCopy.itemID + ", " + (checkedStackCopy.itemID == inputCopy.itemID));
+        LOGGER.info(checkedStackCopy.getMetadata() + ", " + inputCopy.getMetadata() + ", " + (checkedStackCopy.getMetadata() == inputCopy.getMetadata()));
+        LOGGER.info(checkedStackCopy.getData().getValues() + ", " + inputCopy.getData().getValues() + ", " + inputCopy.getData().getValues().containsAll(checkedStackCopy.getData().getValues()));
+        return checkedStackCopy.isStackEqual(inputCopy) && matchesTag(checkedStackCopy, inputCopy);
+    }
+
+    private static boolean matchesTag(ItemStack checkedStack, ItemStack input) {
+        for (Map.Entry<String, Tag<?>> entry : checkedStack.getData().getValue().entrySet()) {
+            if (!input.getData().getValue().containsKey(entry.getKey())
+                || (input.getData().getValue().get(entry.getKey()).getValue() != entry.getValue().getValue() && !input.getData().getValue().get(entry.getKey()).getValue().equals(entry.getValue().getValue()))) {
+                return false;
+            }
+        }
+        return true;
+    }
+
+    private static String getMessage(int itemsCleared, List<? extends Entity> players) {
+        StringBuilder keyBuilder = new StringBuilder("command.commands.clear.success_");
+        if (itemsCleared > 1) {
+            keyBuilder.append("multiple_items_");
+        } else if (itemsCleared == 1) {
+            keyBuilder.append("single_item_");
+        }
+
+        if (players.size() > 1) {
+            keyBuilder.append("multiple_entities");
+        } else if (players.size() == 1) {
+            keyBuilder.append("single_entity");
+        }
+
+        return I18n.getInstance().translateKeyAndFormat(keyBuilder.toString(), itemsCleared, players.size());
+    }
 }
